<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Province</title>
</head>
<body>
    <div class="container">
        <div class="d-flex justify-content-center mt-5">
        <div class="card card-danger w-50">
            <div class="card-header">
                <h3 class="card-title">Tỉnh thành</h3>
            </div>
            <div class="card-body">
                <div class="row form-group">
                    <label for="" class="col-sm-3">Tỉnh thành</label>
                    <div class="col-sm-9">
                        <input id="inp-province" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <label for="" class="col-sm-3">Mã</label>
                    <div class="col-sm-9">
                        <input id="inp-code" type="text" class="form-control">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-sm-6">
                        <button id="btn-add" class="btn btn-primary">Add</button>
                        <button id="btn-update" class="btn btn-primary" style="display: none;">Update</button>
                        <button id="btn-delete" class="btn btn-danger" style="display: none;">Delete</button>
                    </div>
                </div>
                
            </div>
        </div>

    </div>
    <table id="table-province" class="table table-stripped table-bordered table-hover">
        <thead>
            <tr>
                <th>STT</th>
                <th>Province</th>
                <th>Code</th>
            </tr>
        </thead>
        <tbody>

        </tbody>
    </table>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */  
    var gTableProvince = $("#table-province").DataTable({
        columns: [
            { data: "id"},
            { data: "name"},
            { data: "code"}
        ]
    })

    var gProvinceId = null;
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    // Thực thi sự kiện tải trang
    onPageLoading();
    
    // Thực thi sự kiến nhấn vào row
    $("#table-province").on("click", "tr", function() {
        onClickOnProvinceRow(this);
    });

    // Thực thi sự kiện add tỉnh mới
    $("#btn-add").on("click", function() {
        onBtnAddNewProvinceClick();
    });

    // Thực thi sự kiện nhấn nút update province
    $("#btn-update").on("click", function() {
        onBtnUpdateProvinceClick();
    })

    // Thực thi sự kiện nhất nút delete province
    $("#btn-delete").on("click", function() {
        onBtnDeleteProvinceClick();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // Hàm sự kiện tải trang
    function onPageLoading() {
        callApiToLoadListProvince();
    }
    

    // Hàm sự kiện nhấn nút add province
    function onBtnAddNewProvinceClick() {
        var vNewProvince = {
            name: "",
            code: ""
        }
        getDataProvinceForm(vNewProvince);
        var vValidate = validateProvince(vNewProvince);
        if(vValidate) {
            callApiToCreateNewProvince(vNewProvince);
        }

    }

    // Hàm sự kiện nhấn nút update province
    function onBtnUpdateProvinceClick() {
        var vUpdateProvince = {
            name: "",
            code: ""
        }
        getDataProvinceForm(vUpdateProvince);
        var vValidate = validateProvince(vUpdateProvince);
        if(vValidate) {
            callApiToUpdateProvince(vUpdateProvince);
        }
    }

    // Hàm sự kiện nhất nut delete province
    function onBtnDeleteProvinceClick() {
        $.ajax({
            type: "DELETE",
            url: "http://localhost:8080/province/" + gProvinceId,
            success: function(paramRes) {
                alert("Xóa thành công!");
                callApiToLoadListProvince();
                resetFormProvince();
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Xóa thất bại, vui lòng thử lại!")
            }
        })
    }
    // Hàm xử lý sự kiện click vào row trong table
    function onClickOnProvinceRow(paramRow) {
        var vDataRow = gTableProvince.row(paramRow).data();
        gProvinceId = vDataRow.id;
        $("#inp-province").val(vDataRow.name);
        $("#inp-code").val(vDataRow.code);
        $("#btn-add").hide();
        $("#btn-update").show();
        $("#btn-delete").show();

    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // Hàm gọi api load ra danh sách province
    function callApiToLoadListProvince() {
        $.ajax({
            type: "GET",
            url: "http://localhost:8080/provinces",
            success: function(paramRes) {
                console.log(paramRes);
                loadDataToTable(paramRes);
            }
        })
    }

    // Load dữ liệu province vào table
    function loadDataToTable(paramProvinceData) {
        gTableProvince.clear();
        gTableProvince.rows.add(paramProvinceData);
        gTableProvince.draw();
    }

    // Hàm thu thập dữ liệu từ form
    function getDataProvinceForm(paramProvinceData) {
        paramProvinceData.name = $("#inp-province").val();
        paramProvinceData.code = $("#inp-code").val();
    }

    // Hàm validate dữ liệu province
    function validateProvince(paramProvinceData) {
        if(paramProvinceData.name == "") {
            alert("Vui lòng nhập tên tỉnh!");
            return false;
        }
        if(paramProvinceData.code == "") {
            alert("Vui lòng nhập mã tỉnh")
            return false;
        }
        return true;
    }

    // Gọi API để tạo mới 1 tỉnh
    function callApiToCreateNewProvince(paramProvinceData) {
        console.log(paramProvinceData);
        $.ajax({
            type: "POST",
            url: "http://localhost:8080/provinces",
            contentType: "application/json",
            data: JSON.stringify(paramProvinceData),
            success: function(paramRes) {
                alert("Tạo mới thành công!");
                callApiToLoadListProvince();
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Tạo mới thất bại, vui lòng thử lại!");
            }
        })
    }

    // Hàm gọi API để cập nhật province
    function callApiToUpdateProvince(paramProvinceData) {
        $.ajax({
            type: "PUT",
            url: "http://localhost:8080/province/" + gProvinceId,
            contentType: "application/json",
            data: JSON.stringify(paramProvinceData),
            success: function(paramRes) {
                alert("Cập nhật thành công!");
                callApiToLoadListProvince();
                resetFormProvince();
            },
            error: function(paramError) {
                console.log(paramError.status);
                alert("Cập nhật thất bại, vui lòng thử lại!");
            }
        })
    }

    // Hàm reset form
    function resetFormProvince() {
        $("#inp-province").val("");
        $("#inp-code").val("");
        $("#btn-add").show();
        $("#btn-update").hide();
        $("#btn-delete").hide();
    }
</script>
</html>